000100 IDENTIFICATION DIVISION.                                         POS00077
000200 PROGRAM-ID.    GETNBR.                                           95/12/10
000300                                                                  95/12/10
000400 AUTHOR.        LEIF SVALGAARD.                                   95/12/10
000500 DATE-WRITTEN.  95/12/10                                          95/12/10
000600     -REVISED:  95/12/12.                                         95/12/12
000700                                                                  95/12/10
000800 ENVIRONMENT DIVISION.                                            95/12/10
000900                                                                  95/12/10
001000 CONFIGURATION SECTION.                                           95/12/10
001100 SOURCE-COMPUTER. PORTABLE.                                       95/12/10
001200 OBJECT-COMPUTER. PORTABLE.                                       95/12/10
001300                                                                  95/12/10
001400 DATA DIVISION.                                                   95/12/10
001500                                                                  95/12/10
001600 WORKING-STORAGE SECTION.                                         95/12/10
001700                                                                  95/12/10
001800 01  BEGIN-DYNAMIC-STORAGE       PIC X(4)   VALUE "<ETK".         95/12/10
001900                                                                  95/12/10
002000 01  CHAR-HANDLING.                                               95/12/10
002100     02  CHAR-NBR                PIC S9(3)  COMP.                 95/12/11
002200     02  LOCAL-TEXT.                                              95/12/10
002300         03  LOCAL-CHAR          PIC X      OCCURS 81 TIMES.      95/12/10
002400     02  THE-CHAR.                                                95/12/10
002500         03  THE-DIGIT           PIC 9.                           95/12/10
002600     02  THE-POINT-CHAR          PIC X.                           95/12/11
002700     02  THE-SEP-CHAR            PIC X.                           95/12/11
002800                                                                  95/12/10
002900 01  NUMBER-HANDLING.                                             95/12/10
003000     02  THE-NUMBER              PIC 9(18).                       95/12/10
003100     02  THE-SCALE-FACTOR        PIC 9(18).                       95/12/11
003200     02  THE-SIGN                PIC S9.                          95/12/10
003300                                                                  95/12/10
003400 LINKAGE SECTION.                                                 95/12/10
003500                                                                  95/12/10
003600 01  GETNBR-CONTROL.                                              95/12/10
003700     02  SESSION-TASK-ID         PIC X(4).                        95/12/10
003800     02  GETNBR-OPERATION        PIC X(1).                        95/12/10
003900     02  GETNBR-FEEDBACK         PIC X(1).                        95/12/10
004000     02  GETNBR-NUMBER           PIC S9(18).                      95/12/11
004100     02  GETNBR-SCALE-FACTOR     PIC 9(18).                       95/12/11
004200     02  GETNBR-TEXT             PIC X(80).                       95/12/10
004300     02  GETNBR-DECIMAL-POINT    PIC X.                           95/12/11
004400                                                                  95/12/10
004500 PROCEDURE DIVISION                                               95/12/10
004600     USING GETNBR-CONTROL                                         95/12/10
004700     .                                                            95/12/10
004800 BEGIN-PROGRAM.                                                   95/12/10
004900     MOVE SPACE TO GETNBR-FEEDBACK                                95/12/10
005000     PERFORM CHOOSE-POINT-AND-SEP                                 95/12/11
005100     IF GETNBR-OPERATION = "N"                                    95/12/11
005200         MOVE GETNBR-TEXT TO LOCAL-TEXT                           95/12/10
005300         PERFORM GET-THE-NUMBER                                   95/12/10
005400     ELSE                                                         95/12/10
005500         MOVE "OPERR" TO GETNBR-FEEDBACK                          95/12/10
005600     .                                                            95/12/10
005700 RETURN-TO-CALLER.                                                95/12/10
005800     EXIT PROGRAM                                                 95/12/10
005900     .                                                            95/12/10
006000                                                                  95/12/10
006100 CHOOSE-POINT-AND-SEP.                                            95/12/11
006200     IF GETNBR-DECIMAL-POINT = "."                                95/12/11
006300         MOVE "," TO THE-SEP-CHAR                                 95/12/11
006400         MOVE "." TO THE-POINT-CHAR                               95/12/11
006500     ELSE                                                         95/12/11
006600     IF GETNBR-DECIMAL-POINT = ","                                95/12/11
006700         MOVE "." TO THE-SEP-CHAR                                 95/12/11
006800         MOVE "," TO THE-POINT-CHAR                               95/12/11
006900     ELSE                                                         95/12/11
007000         MOVE "," TO THE-SEP-CHAR                                 95/12/11
007100         MOVE "." TO THE-POINT-CHAR                               95/12/11
007200         MOVE "POINT" TO GETNBR-FEEDBACK                          95/12/11
007300     .                                                            95/12/11
007400                                                                  95/12/11
007500 GET-THE-NUMBER.                                                  95/12/10
007600     MOVE +1 TO THE-SIGN                                          95/12/11
007700     MOVE ZEROES TO THE-NUMBER, THE-SCALE-FACTOR                  95/12/11
007800                                                                  95/12/11
007900     PERFORM SKIP-LEADING-TEXT                                    95/12/12
008000       VARYING CHAR-NBR FROM 1 BY 1                               95/12/10
008100         UNTIL CHAR-NBR > 80                                      95/12/10
008200            OR LOCAL-CHAR (CHAR-NBR) IS NUMERIC                   95/12/12
008300            OR LOCAL-CHAR (CHAR-NBR) = "-" OR "+" OR              95/12/12
008400                                       THE-POINT-CHAR             95/12/12
008500                                                                  95/12/10
008600     PERFORM ACCUMULATE-THE-NUMBER                                95/12/10
008700       VARYING CHAR-NBR FROM CHAR-NBR BY 1                        95/12/10
008800         UNTIL LOCAL-CHAR (CHAR-NBR) = SPACE                      95/12/10
008900                                                                  95/12/10
009000     COMPUTE GETNBR-NUMBER = THE-NUMBER * THE-SIGN                95/12/10
009100     IF THE-SCALE-FACTOR = ZEROES                                 95/12/11
009200         MOVE        1         TO GETNBR-SCALE-FACTOR             95/12/11
009300     ELSE                                                         95/12/11
009400         MOVE THE-SCALE-FACTOR TO GETNBR-SCALE-FACTOR             95/12/11
009500     .                                                            95/12/10
009600                                                                  95/12/10
009700 SKIP-LEADING-TEXT.                                               95/12/12
009800     EXIT                                                         95/12/10
009900     .                                                            95/12/10
010000                                                                  95/12/10
010100 ACCUMULATE-THE-NUMBER.                                           95/12/10
010200     MOVE LOCAL-CHAR (CHAR-NBR) TO THE-CHAR                       95/12/10
010300     IF THE-CHAR = THE-POINT-CHAR                                 95/12/11
010400         MOVE 1 TO THE-SCALE-FACTOR                               95/12/11
010500     ELSE                                                         95/12/10
010600     IF THE-CHAR = THE-SEP-CHAR OR "/" OR "+"                     95/12/11
010700         NEXT SENTENCE                                            95/12/11
010800     ELSE                                                         95/12/11
010900     IF THE-CHAR = "-"                                            95/12/10
011000         COMPUTE THE-SIGN = -1 * THE-SIGN                         95/12/11
011100     ELSE                                                         95/12/11
011200     IF THE-CHAR IS NUMERIC                                       95/12/11
011300         COMPUTE THE-NUMBER = 10 * THE-NUMBER + THE-DIGIT         95/12/11
011400         PERFORM CHECK-SCALE-FACTOR                               95/12/11
011500     ELSE                                                         95/12/11
011600         MOVE "SYNTAX ERR" TO GETNBR-FEEDBACK                     95/12/11
011700     .                                                            95/12/10
011800                                                                  95/12/11
011900 CHECK-SCALE-FACTOR.                                              95/12/11
012000     IF THE-SCALE-FACTOR > ZERO                                   95/12/11
012100         COMPUTE THE-SCALE-FACTOR = 10 * THE-SCALE-FACTOR         95/12/11
012200     .                                                            95/12/11